using anbs_cp;

using msoui.Enums;
using msoui.Models;

namespace msoui.Forms;
public sealed partial class MainForm: Form
{
    public MainForm ()
    {
        TempWorkDir = $@"{LikeDelphi.IncludeTrailingBackslash(Path.GetTempPath())}msoui\";
        InitializeComponent();
    }

    public string TempWorkDir { get; set; }

    private void viewButton_Click (object sender, EventArgs e)
    {
        if (dataFileDialog.ShowDialog() == DialogResult.OK)
            dataFileSelector.Text = dataFileDialog.FileName;
    }

    private void exitButton_Click (object sender, EventArgs e)
    {
        Application.Exit();
    }

    private void installButton_Click (object sender, EventArgs e)
    {
        //  
        if (string.IsNullOrWhiteSpace(dataFileSelector.Text) || !File.Exists(dataFileSelector.Text))
        {
            MessageBox.Show($@" {dataFileSelector.Text}  !", @"!", MessageBoxButtons.OK, MessageBoxIcon.Error);

            return;
        }

        //  
        UnPackModel model = new(dataFileSelector.Text, bitsSelector64.Checked ? EBits.Bit64 : EBits.Bit32, TempWorkDir);

        //  
        UnPackForm unPackFrm = new(model);

        // 
        unPackFrm.ShowDialog();

        //  -
        List<string> updatesList = unPackFrm.FileList;

        // 
        unPackFrm.Dispose();

        //   
        UpdatesListForm updatesListForm = new UpdatesListForm(updatesList);

        // 
        DialogResult ulDialogResult = updatesListForm.ShowDialog();

        //  -- 
        if (ulDialogResult == DialogResult.Cancel)
        {
            //       
            CleanThis(updatesList);
            return;
        }

        //
    }

    private void StartForm_Load (object sender, EventArgs e)
    {
        if (!string.IsNullOrWhiteSpace(dataFileSelector.Text) || !File.Exists(dataFileSelector.Text))
            return;

        string dataFileSeek = $"{Application.StartupPath}\\msou.data";

        if (File.Exists(dataFileSeek))
            dataFileSelector.Text = dataFileSeek;
    }

    private void CleanThis(List<string> fileList)
    {
        // 
        foreach (string file in fileList)
            File.Delete(file);

        //  
        Directory.Delete(TempWorkDir, true);
    }
}
