﻿using msoui.Enums;

namespace msoui.Models;

/// <summary>
/// Модель для распаковки
/// </summary>
public class UnPackModel
{
    public UnPackModel(string dataFile, EBits bits, string unPackDir)
    {
        DataFile = dataFile;
        Bits = bits;
        UnPackDir = unPackDir;
    }

    public UnPackModel ()
    {
        DataFile = "";
        Bits = EBits.Bit32;
        UnPackDir = @".\";
    }

    /// <summary>
    /// Файл-данных обновлений
    /// </summary>
    public string DataFile { get; set; }

    /// <summary>
    /// Разрядность MS Office 2016
    /// </summary>
    public EBits Bits { get; set; }

    /// <summary>
    /// Каталог распаковки
    /// </summary>
    public string UnPackDir { get; set; }
}